require "import"
import "android.media.*"
import "java.io.File"
import "android.os.*"
import "android.content.*"
import "android.net.*"
import "android.widget.Button"
import "android.widget.LinearLayout"
import "android.view.View"
import "com.androlua.*"

local vibrator = this.getSystemService(this.VIBRATOR_SERVICE)
if vibrator then vibrator.vibrate(100) end

local folderPath = Environment.getExternalStorageDirectory().getAbsolutePath().."/jieshuo audio recordings/"
local file = File(folderPath)
if not file.exists() then success = file.mkdirs() end

-- Function to play music
function playMusic(player)
    if mp then
        mp.stop()
        mp.release()  -- Ensure MediaPlayer is properly released
        mp = nil
    end

    mp = MediaPlayer()
    mp.setAudioStreamType(AudioManager.STREAM_MUSIC)
    mp.setDataSource(player)
    mp.prepare()
    mp.start()
    mp.setOnCompletionListener {
        onCompletion = function()
            mp.release()
            mp = nil
        end
    }
    return true
end

-- Bitrate options
local bitRateNames = {"32 kbps", "64 kbps", "96 kbps", "128 kbps", "160 kbps", "192 kbps", "256 kbps", "320 kbps"}
local bitRateValues = {32000, 64000, 96000, 128000, 160000, 192000, 256000, 320000}

if not service.getSharedData("defaultAudioBitrate") then
    service.setSharedData("defaultAudioBitrate", bitRateValues[1])
end

-- Dialog for selecting bitrate
local dlg = LuaDialog()
dlg.setCancelable(false)
dlg.setTitle("Bit rate")
dlg.setSingleChoiceItems(bitRateNames, table.find(bitRateValues, service.getSharedData("defaultAudioBitrate")) - 1)
dlg.setButton2("Save")
dlg.onItemClick = function(l, v, p, i)
    service.setSharedData("defaultAudioBitrate", bitRateValues[i])
end

-- Focus and recording logic
local focus = service.getText(node)
if focus == "Back" or focus == "Home" then
    dlg.show()
    return
end

local dlg2 -- Declare dlg2 here so it can be accessed globally

if mr then
    mr.pause()
    local focus2 = this.getText(node)
    local appName = this.getAppName(node)
    local dlg = LuaDialog()
    dlg.setTitle("Recording Paused")
    dlg.setButton("Resume Recording", function()
        mr.resume()
    end)
    dlg.setButton2("Stop Recording", function()
        mr.stop()
        mr.release()
        mr = nil
        if vibrator then vibrator.vibrate(100) end
        
        -- Dialog after stopping recording
        local layout = {
            LinearLayout,
            orientation = "vertical",
            {
                Button,
                text = "Play",
                onClick = function()
                    playMusic(outputFile)
                end
            },
            {
                Button,
                text = "Share",
                onClick = function()
                    service.shareFile(outputFile)
                end
            },
            {
                Button,
                text = "Delete",
                onClick = function()
                    os.remove(outputFile)
                    service.postSpeak(1200, "Recording deleted")
                    dlg2.dismiss()
                end
            },
            {
                Button,
                text = "Open in File Manager",
                onClick = function()
                    this.startActivity(Intent(Intent.ACTION_VIEW).setDataAndType(Uri.parse(folderPath), "resource/folder"))
                    dlg2.dismiss()
                end
            },
            {
                Button,
                text = "connect on telegram",
                onClick = function()
                    local intent = Intent(Intent.ACTION_VIEW, Uri.parse("https://t.me/AndroidTechnologyForTheBlind"))
                    service.startActivity(intent)
                    dlg2.dismiss()
                 end
            }
}

        dlg2 = LuaDialog(this)
        dlg2.View = loadlayout(layout)
        dlg2.setCancelable(false)
        dlg2.setTitle("Result "..fileName)
        dlg2.setButton2("Close")
        dlg2.onDismiss = function()
            appName = nil
            focus2 = nil
            fileName = nil
            layout = nil
            dlg2 = nil
            this.playSoundGestureEnd()
        end
        dlg2.show()
    end)
    dlg.setButton3("Hide Dialog")
    dlg.show()
    this.postClick(500, {{"<Stop Recording"}})
else
    if fileName == nil then
        fileName = os.date("Recording_%d_%m_%y_%H_%M_%S.mp3")
        this.playSoundGestureBegin()
    end

    outputFile = folderPath..fileName
    mr = MediaRecorder()
    mr.setAudioSource(MediaRecorder.AudioSource.MIC)
    mr.setOutputFormat(MediaRecorder.OutputFormat.MPEG_4)
    mr.setAudioEncoder(MediaRecorder.AudioEncoder.AAC)
    mr.setAudioEncodingBitRate(service.getSharedData("defaultAudioBitrate"))
    mr.setOutputFile(outputFile)
    mr.prepare()
    mr.start()
end